package mathvis.halfedge;

import de.jreality.geometry.IndexedFaceSetFactory;
import de.jreality.scene.IndexedFaceSet;
import de.jreality.scene.data.Attribute;
import de.jtem.halfedge.jReality.converter.ConverterHeds2JR;
import de.jtem.halfedge.jReality.converter.ConverterJR2Heds;
import de.jtem.halfedge.jReality.interfaces.Adapter;
import de.jtem.halfedge.jReality.standard.StdJREdge;
import de.jtem.halfedge.jReality.standard.StdJRFace;
import de.jtem.halfedge.jReality.standard.StdJRVertex;
import de.jtem.halfedge.jReality.stdInterfaces.MyCoordinateAdapter;

public class Converter {

	public static IndexedFaceSet ifsFromHeds(HEDS heds) {
		ConverterHeds2JR<StdJRVertex, StdJREdge, StdJRFace> conv = new ConverterHeds2JR<StdJRVertex, StdJREdge, StdJRFace>();
		IndexedFaceSet ifs = conv.heds2ifs(heds, new MyCoordinateAdapter(Adapter.AdapterType.VERTEX_ADAPTER));
		IndexedFaceSetFactory factory = new IndexedFaceSetFactory();
		factory.setGenerateVertexNormals(true);
		factory.setGenerateFaceNormals(true);
		factory.setVertexCount(ifs.getNumPoints());
		factory.setLineCount(ifs.getNumEdges());
		factory.setFaceCount(ifs.getNumFaces());
		factory.setVertexAttribute(Attribute.COORDINATES, ifs.getVertexAttributes(Attribute.COORDINATES));
		factory.setEdgeIndices(ifs.getEdgeAttributes(Attribute.INDICES).toIntArrayArray(null));
		factory.setFaceIndices(ifs.getFaceAttributes(Attribute.INDICES).toIntArrayArray(null));
		factory.update();
		return factory.getIndexedFaceSet();
	}
	
	public static HEDS hedsFromIfs(IndexedFaceSet ifs) {
		ConverterJR2Heds<StdJRVertex, StdJREdge, StdJRFace> conv = new ConverterJR2Heds<StdJRVertex, StdJREdge, StdJRFace>(StdJRVertex.class, StdJREdge.class, StdJRFace.class);
		HEDS heds = new HEDS();
		conv.ifs2heds(ifs, heds, new MyCoordinateAdapter(Adapter.AdapterType.VERTEX_ADAPTER));
		return heds;
	}
}
